#include <groupchat.h>

/* this is the main function if the listener is to manually connect to etherx via a socket */

ehandler gc__etherx;

int main(int argc, char *argv[])
{
    pth_event_t sigevt;
    sigset_t set;
    int help, sig, i, sz;
    char *c, *secret, *ip, *name;

    help = 0;
    c = name = secret = ip = NULL;
    for(i = 1; i < argc; i++)
    {
        /* check for no flag, the name */
        if(*argv[i] != '-')
        {
            name = strdup(argv[i]);
            continue;
        }

        /* check for flags */
        c = argv[i] + 1;
        switch(*c)
        {
            case 'D':
                etherx_debug();
                break;
            case 'e':
                ip = strdup(argv[++i]);
                break;
            case 's':
                secret = strdup(argv[++i]);
                break;
            default:
                help = 1;
        }
    }
 
    if(help || name == NULL)
    {
        printf("Usage:\ngroupchat [-D] [-e 127.0.0.1] [-s secret] groupchat.hostname\n");
        exit(0);
    }

    log_init(LOGSTDERR, NULL);

    log_debug(ZONE, "Loading Transport");

    if(secret == NULL)
        secret = strdup("test");
    etherx_init(secret,ip);

    /* setup dummy ring hook */
    gc__groups = malloc(sizeof(_gcg));
    gc__groups->next = gc__groups->prev = gc__groups;

    gc__etherx = ehandler_new(gc_etherx, name, "jabber:server");

    sigemptyset(&set);
    sigaddset(&set, SIGHUP);
    sigaddset(&set, SIGINT);
    sigaddset(&set, SIGTERM);
    pth_sigmask(SIG_UNBLOCK, &set, NULL);
    sigevt = pth_event(PTH_EVENT_SIGS, &set, &sig);
 
    log_debug(ZONE,"Main loop waiting");
    pth_wait(sigevt);
 
    log_error("groupchat","Received KILL, shutting down");
    gc_die();
    pth_sleep(1); /* one last chance to make sure everyone is done */
    pth_kill();
    return 0;
}


